/*
 * $Id: Parameters.cpp 116 2009-04-30 13:51:41Z moulu $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Multiplier/include/Parameters.h"
#include "Common/include/BitManipulation.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace multiplier {


#undef  FUNCTION
#define FUNCTION "Multiplier::Parameters"
  Parameters::Parameters (uint32_t             size_data,
                          bool                 sign     ,
                          uint32_t             latency  ,
                          uint32_t             delay    ,
                          bool is_toplevel)
  {

    log_begin(Multiplier,FUNCTION);

    _size_data  = size_data;
    _sign       = sign     ;
    _latency    = latency  ;
    _delay      = delay    ;
    _mask       = gen_mask<Tdata_t>(_size_data);
//     _shift_sign = size_data-1;

    test();

    if (is_toplevel)
      {
        copy();
      }

    log_end(Multiplier,FUNCTION);
  };
  
// #undef  FUNCTION
// #define FUNCTION "Multiplier::Parameters (copy)"
//   Parameters::Parameters (Parameters & param)
//   {
//     log_begin(Multiplier,FUNCTION);
//     test();x
//     log_end(Multiplier,FUNCTION);
//   };

#undef  FUNCTION
#define FUNCTION "Multiplier::~Parameters"
  Parameters::~Parameters (void) 
  {
    log_begin(Multiplier,FUNCTION);
    log_end(Multiplier,FUNCTION);
  };

#undef  FUNCTION
#define FUNCTION "Multiplier::copy"
  void Parameters::copy (void) 
  {
    log_begin(Multiplier,FUNCTION);
    log_end(Multiplier,FUNCTION);
  };

}; // end namespace multiplier
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
